var news_categories_link = {
    "india" : "http://deviceforu.com/news_studio/ver2/xmls/india.json",
    "world" : "http://deviceforu.com/news_studio/ver2/xmls/world.json",
    "business" : "http://deviceforu.com/news_studio/ver2/xmls/business.json",
    "sports" : "http://deviceforu.com/news_studio/ver2/xmls/sports.json",
    "scitech" : "http://deviceforu.com/news_studio/ver2/xmls/scitech.json",
    "entertainment" : "http://deviceforu.com/news_studio/ver2/xmls/entertainment.json",
};

var opts = {
    lines: 11 // The number of lines to draw
    , length: 15 // The length of each line
    , width: 5 // The line thickness
    , radius: 8 // The radius of the inner circle
    , scale: 1.25 // Scales overall size of the spinner
    , corners: 1 // Corner roundness (0..1)
    , color: '#000' // #rgb or #rrggbb or array of colors
    , opacity: 0 // Opacity of the lines
    , rotate: 0 // The rotation offset
    , direction: 1 // 1: clockwise, -1: counterclockwise
    , speed: 1 // Rounds per second
    , trail: 55 // Afterglow percentage
    , fps: 20 // Frames per second when using setTimeout() as a fallback for CSS
    , zIndex: 2e9 // The z-index (defaults to 2000000000)
    , className: 'spinner' // The CSS class to assign to the spinner
    , top: '40%' // Top position relative to parent
    , left: '50%' // Left position relative to parent
    , shadow: false // Whether to render a shadow
    , hwaccel: false // Whether to use hardware acceleration
    , position: 'absolute' // Element positioning
};

var spinner;

function validateUrl(value){
      return /^(https?|ftp):\/\/(((([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(%[\da-f]{2})|[!\$&'\(\)\*\+,;=]|:)*@)?(((\d|[1-9]\d|1\d\d|2[0-4]\d|25[0-5])\.(\d|[1-9]\d|1\d\d|2[0-4]\d|25[0-5])\.(\d|[1-9]\d|1\d\d|2[0-4]\d|25[0-5])\.(\d|[1-9]\d|1\d\d|2[0-4]\d|25[0-5]))|((([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])*([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])))\.)+(([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])*([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])))\.?)(:\d*)?)(\/((([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(%[\da-f]{2})|[!\$&'\(\)\*\+,;=]|:|@)+(\/(([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(%[\da-f]{2})|[!\$&'\(\)\*\+,;=]|:|@)*)*)?)?(\?((([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(%[\da-f]{2})|[!\$&'\(\)\*\+,;=]|:|@)|[\uE000-\uF8FF]|\/|\?)*)?(\#((([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(%[\da-f]{2})|[!\$&'\(\)\*\+,;=]|:|@)|\/|\?)*)?$/i.test(value);
}

function openInBrowser(url) {
    var ref = cordova.InAppBrowser.open(url, '_system', 'location=yes');
}

function list_news(category) {    
    $.getJSON(news_categories_link[category], '', function(result) {
        var target = document.getElementById('spinnerdiv');
        var spinner = new Spinner(opts).spin(target);
        $.each(result, function(i, field) {
            if (category == "entertainment") {
                $('#newscategory').html("Entertainment News");
            }
            else if (category == "world") {
                $('#newscategory').html("World News");
            }
            else if (category == "business") {
                $('#newscategory').html("Business News");
            }
            else if (category == "sports") {
                $('#newscategory').html("Sports News");
            }
            else if (category == "scitech") {
                $('#newscategory').html("Science & Technology News");
            }
            else {
                $('#newscategory').html('India News');
            }
            
            var news_title = $.parseHTML(i);
            var news_publish_date = result[i].pubDate;
            var news_image = validateUrl(result[i].image) ? result[i].image : '';
            var news_link = result[i].link;
            var news_source = result[i].source;
            var news_desc = result[i].description;
            
            if (news_desc !== '' && news_desc !== null) {
                var regex = /(<([^>]+)>)/ig;
                news_desc = news_desc.replace(regex, '');
            }
            
            var source = $('<p></p>').html('source: ' + news_source);
            var title = $('<center></center>').html(news_title);
            title = $('<h2></h2>').attr('style', "font-size: 22px;  white-space: initial; !important;").html(title);
            var pubdate = $('<center></center>').text(news_publish_date);
            pubdate = $('<p style="font-size: 12px; font-family: Courier New;"></p>').html(pubdate);
            var desc = $('<p style="font-size: 18px; white-space: initial; !important;"></p>').html(news_desc);
            if (news_image !== '' && news_image !== null) {
                var image = $('<img/>').attr({'style' : "height: auto; width: 100%; border: 1px solid #000; !important;", 'src' : news_image});
                image = $('<center></center>').html(image);
                var link = $('<a></a>').attr({style : "background-color: white; !important", href : "javascript:openInBrowser('" + news_link + "');"}).html([source, title, pubdate, image, desc]);
            } else {
                var link = $('<a></a>').attr({style : "background-color: white; !important", href : "javascript:openInBrowser('" + news_link + "');"}).html([source, title, pubdate, desc]);
            }
            var li = $('<li></li>').html(link);
            $('#newslist').append($('<ul></ul>').attr({"data-role": "listview", "data-inset": "true", "data-icon": "false"}).html(li));
            
        });
        $('#newslist').append('<link rel="stylesheet" href="css/jquery.mobile-1.4.5.min.css"><script src="js/jquery-1.11.3.min.js"></script><script src="js/jquery.mobile-1.4.5.min.js"></script>');
        document.getElementById('spinnerdiv').innerHTML = '';
    });
}

function switchnews(category) {
    $("#newslist").html("");
    $("#newslist").html('<center><p style="font-size: 20px;" id="newscategory"></p></center>');
    list_news(category);
}

function checkConnection() {
    var networkState = navigator.connection.type;
    //alert(networkState);
    if (networkState === Connection.NONE) {
        alert("Connection trouble.");
        return false;
    }
    return true;
}

function main(category) {
    var target = document.getElementById('spinnerdiv');
    var spinner = new Spinner(opts).spin(target);
    if (checkConnection() === true) {
        switchnews(category);
    }
    
}
